package jemu.core.device;
import jemu.ui.CPCPrinter;

/**
 * Title:        JEMU
 * Description:  The Java Emulation Platform
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class DeviceMapping {

  protected Device device;
  protected int mask;
  protected int test;
  protected int printer;

  public DeviceMapping(Device device, int mask, int test) {
    this.device = device;
    this.mask = mask;
    this.test = test;
  }

  public int readPort(int port) {
      if (port ==0x0000fefe)
        return 0xa0;
      else
    return (port & mask) == test ? device.readPort(port) : -1;
  }

  public void writePort(int port, int value) {
    if ((port & mask) == test){
      device.writePort(port,value);
    } 
        if (port == 0x0ef32){
            if (value != 0x0a)
                CPCPrinter.printer = CPCPrinter.printer + CPCPrinter.asciitxt[value];
            else
                CPCPrinter.DumpText();
        }
  }
}